(function(){
    console.log('Responsive WebGL Template by SIMMER.io v2019.02.08');
    console.log('Available at: https://assetstore.unity.com/packages/tools/gui/responsive-webgl-template-117308 for free!');
    console.log('Host your WebGL Game at SIMMER.io for free!');

    const q = (selector) => document.querySelector(selector);

    const gameContainer = q('#gameContainer');

    const targetWidth = 720; // Target width
    const targetHeight = 1280; // Target height

    let gCanvasElement = null;

    const setDimensions = () => {
        const winW = window.innerWidth;
        const winH = window.innerHeight;
        const scale = Math.min(winW / targetWidth, winH / targetHeight);

        const newWidth = Math.round(targetWidth * scale);
        const newHeight = Math.round(targetHeight * scale);

        gameContainer.style.width = newWidth + 'px';
        gameContainer.style.height = newHeight + 'px';

        gameContainer.style.left = '50%';
        gameContainer.style.top = '50%';
        gameContainer.style.transform = 'translate(-50%, -50%)';

        if (gCanvasElement) {
            gCanvasElement.setAttribute('width', newWidth);
            gCanvasElement.setAttribute('height', newHeight);
        }
    }

    window.setDimensions = setDimensions;

    const registerCanvasWatcher = () => {
        let debounceTimeout = null;
        const debouncedSetDimensions = () => {
            if (debounceTimeout !== null) {
                clearTimeout(debounceTimeout);
            }
            debounceTimeout = setTimeout(setDimensions, 200);
        }
        window.addEventListener('resize', debouncedSetDimensions, false);
        setDimensions();
    }

    window.UnityLoader.Error.handler = function () { }

    const getCanvasFromMutationsList = (mutationsList) => {
        for (let mutationItem of mutationsList){
            for (let addedNode of mutationItem.addedNodes){
                if (addedNode.id === ''){
                    return addedNode;
                }
            }
        }
        return null;
    }

    const i = 0;
    new MutationObserver(function (mutationsList) {
        const canvas = getCanvasFromMutationsList(mutationsList)
        if (canvas){
            gCanvasElement = canvas;
            registerCanvasWatcher();

            new MutationObserver(function (attributesMutation) {
                this.disconnect();
                setTimeout(setDimensions, 1)
                q('.simmer').classList.add('hide');
            }).observe(canvas, {attributes:true});

            this.disconnect();
        }
    }).observe(gameContainer, {childList:true});

})();
